require(wavelets)
require(tuneR)
JSB<-readMP3("jsbdminor1004.mp3")
NN=2^16
VOICE=JSB@left[1:NN]

SR=JSB@samp.rate
SRR=SR/NN

###Wave decomp
plot(dwt(as.ts(VOICE)))
Sys.sleep(7)

dev.new()

####Spectral decomp
fVOICE <- fft(VOICE)
par(mfrow=c(2,1))
plot(VOICE,type="l",xaxt="n",yaxt="n",xlab="time",ylab="")
title(main="signal")

plot(Mod(fVOICE)[1:(NN/2)],type="l",yaxt="n",xaxt="n",xlab="freq",ylab="")
axis(1, at=seq(from=0,to=NN/2,length.out=8),
     labels=c("",round(SRR*seq(from=0,to=NN/2,length.out=8)[-1],0)))
title(main="spectrum")

Sys.sleep(8)

plot(Mod(fVOICE)[1:1760],type="l",yaxt="n",xaxt="n",xlab="freq",ylab="")
axis(1, at=seq(from=0,to=1760,length.out=8),
     labels=c("",round(SRR*seq(from=0,to=1760,length.out=8)[-1],0)))
title(main="spectrum")
plot(Mod(fVOICE)[1:640],type="l",yaxt="n",xaxt="n",xlab="freq",ylab="")
axis(1, at=seq(from=0,to=640,length.out=8),
     labels=c("",round(SRR*seq(from=0,to=640,length.out=8)[-1],0)))
title(main="spectrum")
Sys.sleep(18)

## Subsampling

for (halving in 1:6){
K=2^halving
N=NN/K
DECIM <- 1:N

sampVOICE <- VOICE[K*DECIM]
plot(VOICE,type="l",xaxt="n",xlab="time",ylab="")
axis(1, at=seq(from=0,to=NN,length.out=5),
     labels=seq(from=0,to=NN,length.out=5))
title(main="signal")
plot(sampVOICE,type="l",xaxt="n",xlab="time",ylab="")
axis(1, at=seq(from=0,to=N,length.out=5),
     labels=seq(from=0,to=NN,length.out=5))
title(main=paste("signal decimated by",K))
Sys.sleep(7)

fsampVOICE <- fft(sampVOICE)
REP=rep(0,(NN-N)/4)


### Reconstruction
nfVOICE <- c(fVOICE[(NN/2+1):NN], fVOICE[1:(NN/2)])

nfsampVOICE <- c(fsampVOICE[(N/2 + 1):N], fsampVOICE[1:(N/2)])

plot(Re(fft(nfVOICE,inv=T)),type="l",xaxt="n",yaxt="n",xlab="",ylab="")
axis(1, at=seq(from=0,to=NN,length.out=5),
     labels=seq(from=0,to=NN,length.out=5))
title(main="signal")
plot(Re(fft(nfsampVOICE,inv=T)),type="l",xaxt="n",yaxt="n",xlab="",ylab="")
axis(1, at=seq(from=0,to=N,length.out=5),
     labels=seq(from=0,to=NN,length.out=5))
title(main=paste("rec signal decimated by",K))
Sys.sleep(7)


###Power spectrum
plot(Mod(fVOICE)[1:(NN/4)],type="l",yaxt="n",xaxt="n",xlab="freq",ylab="")
axis(1, at=seq(from=0,to=NN/4,length.out=8),
     labels=c("",round(SRR*seq(from=0,to=NN/4,length.out=8)[-1],0)))
title(main="spectra of signal")
plot(c(Mod(fsampVOICE)[1:(N/4)],REP),type="l",yaxt="n",xaxt="n",xlab="freq",ylab="")
axis(1, at=seq(from=0,to=NN/4,length.out=8),
     labels=c("",round(SRR*seq(from=0,to=NN/4,length.out=8)[-1],0)))
title(main=paste("spectra of signal decimated by",K))
#plot(Mod(fsampVOICE)[1:N/2],,"l")
Sys.sleep(10)

}

